Index: src/analysis_correlation.cpp
===================================================================
--- src/analysis_correlation.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/analysis_correlation.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -341,47 +325,42 @@
   Vector checkX;
 
-  if ((Surface == NULL) || (LC == NULL) || (molecules->ListOfMolecules.empty())) {
+  if ((Surface == NULL) || (LC == NULL) || (molecules.empty())) {
     DoLog(1) && (Log() << Verbose(1) <<"No Tesselation, no LinkedCell or no molecule given." << endl);
     return outmap;
   }
-  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
+  for (std::vector<molecule *>::const_iterator MolWalker = molecules.begin(); MolWalker != molecules.end(); MolWalker++)
     (*MolWalker)->doCountAtoms();
   outmap = new CorrelationToSurfaceMap;
   double ShortestDistance = 0.;
   BoundaryTriangleSet *ShortestTriangle = NULL;
-  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
-    if ((*MolWalker)->ActiveFlag) {
-      double * FullMatrix = ReturnFullMatrixforSymmetric(World::getInstance().getDomain());
-      double * FullInverseMatrix = InverseMatrix(FullMatrix);
-      DoLog(2) && (Log() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
-      for (molecule::const_iterator iter = (*MolWalker)->begin(); iter != (*MolWalker)->end(); ++iter) {
-        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << **iter << "." << endl);
-        for (vector<element *>::const_iterator type = elements.begin(); type != elements.end(); ++type)
-          if ((*type == NULL) || ((*iter)->type == *type)) {
-            periodicX = *(*iter)->node;
-            periodicX.MatrixMultiplication(FullInverseMatrix);  // x now in [0,1)^3
-            // go through every range in xyz and get distance
-            ShortestDistance = -1.;
-            for (n[0]=-ranges[0]; n[0] <= ranges[0]; n[0]++)
-              for (n[1]=-ranges[1]; n[1] <= ranges[1]; n[1]++)
-                for (n[2]=-ranges[2]; n[2] <= ranges[2]; n[2]++) {
-                  checkX = Vector(n[0], n[1], n[2]) + periodicX;
-                  checkX.MatrixMultiplication(FullMatrix);
-                  TriangleIntersectionList Intersections(&checkX,Surface,LC);
-                  distance = Intersections.GetSmallestDistance();
-                  triangle = Intersections.GetClosestTriangle();
-                  if ((ShortestDistance == -1.) || (distance < ShortestDistance)) {
-                    ShortestDistance = distance;
-                    ShortestTriangle = triangle;
-                  }
+  for (std::vector<molecule *>::const_iterator MolWalker = molecules.begin(); MolWalker != molecules.end(); MolWalker++) {
+    Matrix FullMatrix = World::getInstance().getDomain().getM();
+    Matrix FullInverseMatrix = World::getInstance().getDomain().getMinv();
+    DoLog(2) && (Log() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
+    for (molecule::const_iterator iter = (*MolWalker)->begin(); iter != (*MolWalker)->end(); ++iter) {
+      DoLog(3) && (Log() << Verbose(3) << "Current atom is " << **iter << "." << endl);
+      for (vector<const element *>::const_iterator type = elements.begin(); type != elements.end(); ++type)
+        if ((*type == NULL) || ((*iter)->getType() == *type)) {
+          periodicX = FullInverseMatrix * ((*iter)->getPosition()); // x now in [0,1)^3
+          // go through every range in xyz and get distance
+          ShortestDistance = -1.;
+          for (n[0]=-ranges[0]; n[0] <= ranges[0]; n[0]++)
+            for (n[1]=-ranges[1]; n[1] <= ranges[1]; n[1]++)
+              for (n[2]=-ranges[2]; n[2] <= ranges[2]; n[2]++) {
+                checkX = FullMatrix * (Vector(n[0], n[1], n[2]) + periodicX);
+                TriangleIntersectionList Intersections(checkX,Surface,LC);
+                distance = Intersections.GetSmallestDistance();
+                triangle = Intersections.GetClosestTriangle();
+                if ((ShortestDistance == -1.) || (distance < ShortestDistance)) {
+                  ShortestDistance = distance;
+                  ShortestTriangle = triangle;
                 }
-            // insert
-            outmap->insert ( pair<double, pair<atom *, BoundaryTriangleSet*> >(ShortestDistance, pair<atom *, BoundaryTriangleSet*> (*iter, ShortestTriangle) ) );
-            //Log() << Verbose(1) << "INFO: Inserting " << Walker << " with distance " << ShortestDistance << " to " << *ShortestTriangle << "." << endl;
-          }
-      }
-      delete[](FullMatrix);
-      delete[](FullInverseMatrix);
-    }
+              }
+          // insert
+          outmap->insert ( pair<double, pair<atom *, BoundaryTriangleSet*> >(ShortestDistance, pair<atom *, BoundaryTriangleSet*> (*iter, ShortestTriangle) ) );
+          //Log() << Verbose(1) << "INFO: Inserting " << Walker << " with distance " << ShortestDistance << " to " << *ShortestTriangle << "." << endl;
+        }
+    }
+  }
 
   return outmap;
@@ -438,5 +417,5 @@
     *file << runner->first;
     for (int i=0;i<NDIM;i++)
-      *file << "\t" << setprecision(8) << (runner->second.first->node->at(i) - runner->second.second->at(i));
+      *file << "\t" << setprecision(8) << (runner->second.first->at(i) - runner->second.second->at(i));
     *file << endl;
   }
@@ -453,6 +432,8 @@
   if (!map->empty())
     for (CorrelationToSurfaceMap::const_iterator runner = map->begin(); runner != map->end(); ++runner) {
-      *file << setprecision(8) << runner->first << "\t" << *(runner->second.first) << "\t" << *(runner->second.second) << endl;
-    }
-};
-
+      *file << setprecision(8) << runner->first << "\t";
+      *file << *(runner->second.first) << "\t";
+      *file << *(runner->second.second) << endl;
+    }
+};
+
Index: src/analysis_correlation.hpp
===================================================================
--- src/analysis_correlation.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/analysis_correlation.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -22,8 +22,10 @@
 // STL headers
 #include <map>
+#include <vector>
 
 #include "defs.hpp"
 
 #include "atom.hpp"
+#include "Helpers/Verbose.hpp"
 
 /****************************************** forward declarations *****************************/
@@ -32,5 +34,4 @@
 class element;
 class LinkedCell;
-class MoleculeListClass;
 class Tesselation;
 class Vector;
@@ -45,10 +46,10 @@
 /********************************************** declarations *******************************/
 
-PairCorrelationMap *PairCorrelation(MoleculeListClass * const &molecules, const std::vector<element *> &elements);
-CorrelationToPointMap *CorrelationToPoint(MoleculeListClass * const &molecules, const std::vector<element *> &elements, const Vector *point );
-CorrelationToSurfaceMap *CorrelationToSurface(MoleculeListClass * const &molecules, const std::vector<element *> &elements, const Tesselation * const Surface, const LinkedCell *LC );
-PairCorrelationMap *PeriodicPairCorrelation(MoleculeListClass * const &molecules, const std::vector<element *> &elements, const int ranges[NDIM] );
-CorrelationToPointMap *PeriodicCorrelationToPoint(MoleculeListClass * const &molecules, const std::vector<element *> &elements, const Vector *point, const int ranges[NDIM] );
-CorrelationToSurfaceMap *PeriodicCorrelationToSurface(MoleculeListClass * const &molecules, const std::vector<element *> &elements, const Tesselation * const Surface, const LinkedCell *LC, const int ranges[NDIM] );
+PairCorrelationMap *PairCorrelation(std::vector<molecule *> &molecules, const std::vector<const element *> &elements);
+CorrelationToPointMap *CorrelationToPoint(std::vector<molecule *> &molecules, const std::vector<const element *> &elements, const Vector *point );
+CorrelationToSurfaceMap *CorrelationToSurface(std::vector<molecule *> &molecules, const std::vector<const element *> &elements, const Tesselation * const Surface, const LinkedCell *LC );
+PairCorrelationMap *PeriodicPairCorrelation(std::vector<molecule *> &molecules, const std::vector<const element *> &elements, const int ranges[NDIM] );
+CorrelationToPointMap *PeriodicCorrelationToPoint(std::vector<molecule *> &molecules, const std::vector<const element *> &elements, const Vector *point, const int ranges[NDIM] );
+CorrelationToSurfaceMap *PeriodicCorrelationToSurface(std::vector<molecule *> &molecules, const std::vector<const element *> &elements, const Tesselation * const Surface, const LinkedCell *LC, const int ranges[NDIM] );
 int GetBin ( const double value, const double BinWidth, const double BinStart );
 void OutputCorrelation( ofstream * const file, const BinPairMap * const map );
Index: src/analyzer.cpp
===================================================================
--- src/analyzer.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/analyzer.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -8,14 +8,4 @@
 //============================ INCLUDES ===========================
 
-#include "Helpers/MemDebug.hpp"
-
-#include <cstring>
-
-#include "datacreator.hpp"
-#include "helpers.hpp"
-#include "memoryallocator.hpp"
-#include "parser.hpp"
-#include "periodentafel.hpp"
-
 // include config.h
 #ifdef HAVE_CONFIG_H
@@ -23,4 +13,13 @@
 #endif
 
+#include "Helpers/MemDebug.hpp"
+
+#include <cstring>
+
+#include "datacreator.hpp"
+#include "Helpers/helpers.hpp"
+#include "parser.hpp"
+#include "periodentafel.hpp"
+#include "Helpers/Verbose.hpp"
 
 //============================== MAIN =============================
Index: src/atom.cpp
===================================================================
--- src/atom.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -4,4 +4,9 @@
  *
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -12,9 +17,12 @@
 #include "element.hpp"
 #include "lists.hpp"
-#include "memoryallocator.hpp"
 #include "parser.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "World.hpp"
 #include "molecule.hpp"
+#include "Shapes/Shape.hpp"
+
+#include <iomanip>
+#include <iostream>
 
 /************************************* Functions for class atom *************************************/
@@ -24,19 +32,20 @@
  */
 atom::atom() :
-  father(this), sort(&nr), mol(0)
-{
-  node = &x;  // TesselPoint::x can only be referenced from here
-};
+  father(this),
+  sort(&nr),
+  mol(0)
+{};
 
 /** Constructor of class atom.
  */
 atom::atom(atom *pointer) :
-    ParticleInfo(pointer),father(pointer), sort(&nr)
-{
-  type = pointer->type;  // copy element of atom
-  x = pointer->x; // copy coordination
-  v = pointer->v; // copy velocity
+    ParticleInfo(pointer),
+    father(pointer),
+    sort(&nr)
+{
+  setType(pointer->getType());  // copy element of atom
+  setPosition(pointer->getPosition()); // copy coordination
+  AtomicVelocity = pointer->AtomicVelocity; // copy velocity
   FixedIon = pointer->FixedIon;
-  node = &x;
   mol = 0;
 };
@@ -46,9 +55,8 @@
   res->father = this;
   res->sort = &res->nr;
-  res->type = type;
-  res->x = this->x;
-  res->v = this->v;
+  res->setType(getType());
+  res->setPosition(this->getPosition());
+  res->AtomicVelocity = this->AtomicVelocity;
   res->FixedIon = FixedIon;
-  res->node = &x;
   res->mol = 0;
   World::getInstance().registerAtom(res);
@@ -107,4 +115,8 @@
 };
 
+bool atom::isFather(const atom *ptr){
+  return ptr==father;
+}
+
 /** Checks whether atom is within the given box.
  * \param offset offset to box origin
@@ -112,7 +124,7 @@
  * \return true - is inside, false - is not
  */
-bool atom::IsInParallelepiped(const Vector offset, const double *parallelepiped) const
-{
-  return (node->IsInParallelepiped(offset, parallelepiped));
+bool atom::IsInShape(const Shape& shape) const
+{
+  return shape.isInside(getPosition());
 };
 
@@ -139,8 +151,8 @@
   if (out != NULL) {
     *out << "Ion_Type" << ElementNo << "_" << AtomNo << "\t"  << fixed << setprecision(9) << showpoint;
-    *out << x[0] << "\t" << x[1] << "\t" << x[2];
+    *out << at(0) << "\t" << at(1) << "\t" << at(2);
     *out << "\t" << FixedIon;
-    if (v.Norm() > MYEPSILON)
-      *out << "\t" << scientific << setprecision(6) << v[0] << "\t" << v[1] << "\t" << v[2] << "\t";
+    if (AtomicVelocity.Norm() > MYEPSILON)
+      *out << "\t" << scientific << setprecision(6) << AtomicVelocity[0] << "\t" << AtomicVelocity[1] << "\t" << AtomicVelocity[2] << "\t";
     if (comment != NULL)
       *out << " # " << comment << endl;
@@ -159,13 +171,16 @@
   * \return true - \a *out present, false - \a *out is NULL
  */
-bool atom::OutputArrayIndexed(ostream * const out, const int *ElementNo, int *AtomNo, const char *comment) const
-{
-  AtomNo[type->Z]++;  // increment number
-  if (out != NULL) {
-    *out << "Ion_Type" << ElementNo[type->Z] << "_" << AtomNo[type->Z] << "\t"  << fixed << setprecision(9) << showpoint;
-    *out << x[0] << "\t" << x[1] << "\t" << x[2];
+bool atom::OutputArrayIndexed(ostream * const out,const enumeration<const element*> &elementLookup, int *AtomNo, const char *comment) const
+{
+  AtomNo[getType()->Z]++;  // increment number
+  if (out != NULL) {
+    const element *elemental = getType();
+    cout << "Looking for atom with element " << *elemental << endl;
+    ASSERT(elementLookup.there.find(elemental)!=elementLookup.there.end(),"Type of this atom was not in the formula upon enumeration");
+    *out << "Ion_Type" << elementLookup.there.find(elemental)->second << "_" << AtomNo[elemental->Z] << "\t"  << fixed << setprecision(9) << showpoint;
+    *out << at(0) << "\t" << at(1) << "\t" << at(2);
     *out << "\t" << FixedIon;
-    if (v.Norm() > MYEPSILON)
-      *out << "\t" << scientific << setprecision(6) << v[0] << "\t" << v[1] << "\t" << v[2] << "\t";
+    if (AtomicVelocity.Norm() > MYEPSILON)
+      *out << "\t" << scientific << setprecision(6) << AtomicVelocity[0] << "\t" << AtomicVelocity[1] << "\t" << AtomicVelocity[2] << "\t";
     if (comment != NULL)
       *out << " # " << comment << endl;
@@ -184,5 +199,5 @@
 {
   if (out != NULL) {
-    *out << type->symbol << "\t" << x[0] << "\t" << x[1] << "\t" << x[2] << "\t" << endl;
+    *out << getType()->getSymbol() << "\t" << at(0) << "\t" << at(1) << "\t" << at(2) << "\t" << endl;
     return true;
   } else
@@ -199,7 +214,7 @@
 bool atom::OutputTrajectory(ofstream * const out, const int *ElementNo, int *AtomNo, const int step) const
 {
-  AtomNo[type->Z]++;
-  if (out != NULL) {
-    *out << "Ion_Type" << ElementNo[type->Z] << "_" << AtomNo[type->Z] << "\t"  << fixed << setprecision(9) << showpoint;
+  AtomNo[getType()->Z]++;
+  if (out != NULL) {
+    *out << "Ion_Type" << ElementNo[getType()->Z] << "_" << AtomNo[getType()->Z] << "\t"  << fixed << setprecision(9) << showpoint;
     *out << Trajectory.R.at(step)[0] << "\t" << Trajectory.R.at(step)[1] << "\t" << Trajectory.R.at(step)[2];
     *out << "\t" << FixedIon;
@@ -222,5 +237,5 @@
 {
   if (out != NULL) {
-    *out << type->symbol << "\t";
+    *out << getType()->getSymbol() << "\t";
     *out << Trajectory.R.at(step)[0] << "\t";
     *out << Trajectory.R.at(step)[1] << "\t";
@@ -238,5 +253,7 @@
 void atom::OutputMPQCLine(ostream * const out, const Vector *center, int *AtomNo = NULL) const
 {
-  *out << "\t\t" << type->symbol << " [ " << x[0]-center->at(0) << "\t" << x[1]-center->at(1) << "\t" << x[2]-center->at(2) << " ]" << endl;
+  Vector recentered(getPosition());
+  recentered -= *center;
+  *out << "\t\t" << getType()->getSymbol() << " [ " << recentered[0] << "\t" << recentered[1] << "\t" << recentered[2] << " ]" << endl;
   if (AtomNo != NULL)
     *AtomNo++;
@@ -261,5 +278,5 @@
 double atom::DistanceSquaredToVector(const Vector &origin) const
 {
-  return origin.DistanceSquared(x);
+  return DistanceSquared(origin);
 };
 
@@ -270,5 +287,5 @@
 double atom::DistanceToVector(const Vector &origin) const
 {
-  return origin.distance(x);
+  return distance(origin);
 };
 
@@ -285,4 +302,17 @@
 };
 
+std::ostream & atom::operator << (std::ostream &ost) const
+{
+  ParticleInfo::operator<<(ost);
+  ost << "," << getPosition();
+  return ost;
+}
+
+std::ostream & operator << (std::ostream &ost, const atom &a)
+{
+  a.ParticleInfo::operator<<(ost);
+  ost << "," << a.getPosition();
+  return ost;
+}
 
 bool operator < (atom &a, atom &b)
@@ -319,4 +349,8 @@
 }
 
+/** Makes the atom be contained in the new molecule \a *_mol.
+ * Uses atom::removeFromMolecule() to delist from old molecule.
+ * \param *_mol pointer to new molecule
+ */
 void atom::setMolecule(molecule *_mol){
   // take this atom from the old molecule
@@ -324,8 +358,17 @@
   mol = _mol;
   if(!mol->containsAtom(this)){
-    mol->AddAtom(this);
-  }
-}
-
+    mol->insert(this);
+  }
+}
+
+/** Returns pointer to the molecule which atom belongs to.
+ * \return containing molecule
+ */
+molecule* atom::getMolecule() const {
+  return mol;
+}
+
+/** Erases the atom in atom::mol's list of atoms and sets it to zero.
+ */
 void atom::removeFromMolecule(){
   if(mol){
Index: src/atom.hpp
===================================================================
--- src/atom.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -18,8 +18,9 @@
 #endif
 
-#include <iostream>
+#include <iosfwd>
 #include <list>
 #include <vector>
 
+#include "Helpers/helpers.hpp"
 #include "atom_atominfo.hpp"
 #include "atom_bondedparticle.hpp"
@@ -27,5 +28,5 @@
 #include "atom_particleinfo.hpp"
 #include "atom_trajectoryparticle.hpp"
-#include "tesselation.hpp"
+#include "TesselPoint.hpp"
 #include "types.hpp"
 
@@ -35,4 +36,5 @@
 class World;
 class molecule;
+class Shape;
 
 /********************************************** declarations *******************************/
@@ -41,5 +43,5 @@
  * Class incorporates position, type
  */
-class atom : public TesselPoint, public TrajectoryParticle, public GraphNode, public BondedParticle, public virtual ParticleInfo, public virtual AtomInfo {
+class atom : public TrajectoryParticle, public GraphNode, public BondedParticle, public TesselPoint {
   friend atom* NewAtom(atomId_t);
   friend void  DeleteAtom(atom*);
@@ -51,5 +53,5 @@
 
   bool OutputIndexed(ofstream * const out, const int ElementNo, const int AtomNo, const char *comment = NULL) const;
-  bool OutputArrayIndexed(ostream * const out, const int *ElementNo, int *AtomNo, const char *comment = NULL) const;
+  bool OutputArrayIndexed(ostream * const out,const enumeration<const element*>&, int *AtomNo, const char *comment = NULL) const;
   bool OutputXYZLine(ofstream *out) const;
   bool OutputTrajectory(ofstream * const out, const int *ElementNo, int *AtomNo, const int step) const;
@@ -60,4 +62,5 @@
 
   void EqualsFather ( const atom *ptr, const atom **res ) const;
+  bool isFather(const atom *ptr);
   void CorrectFather();
   atom *GetTrueFather();
@@ -66,5 +69,5 @@
   double DistanceToVector(const Vector &origin) const;
   double DistanceSquaredToVector(const Vector &origin) const;
-  bool IsInParallelepiped(const Vector offset, const double *parallelepiped) const;
+  bool IsInShape(const Shape&) const;
 
   // getter and setter
@@ -89,5 +92,9 @@
 
    void setMolecule(molecule*);
+   molecule* getMolecule() const;
    void removeFromMolecule();
+
+   // Output operator
+   std::ostream & operator << (std::ostream &ost) const;
 
   protected:
@@ -117,4 +124,9 @@
 
 /**
+ * Global output operator for class atom.
+ */
+std::ostream & operator << (std::ostream &ost, const atom &_atom);
+
+/**
  * internal method used by the world. Do not use if you don't know what you are doing.
  * You might get burned...
Index: src/atom_atominfo.cpp
===================================================================
--- src/atom_atominfo.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_atominfo.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,13 +6,33 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "periodentafel.hpp"
 #include "World.hpp"
+#include "element.hpp"
 #include "atom_atominfo.hpp"
 
 /** Constructor of class AtomInfo.
  */
-AtomInfo::AtomInfo() : type(NULL) {};
+AtomInfo::AtomInfo() :
+  AtomicElement(NULL)
+{};
+
+/** Copy constructor of class AtomInfo.
+ */
+AtomInfo::AtomInfo(const AtomInfo &_atom) :
+    AtomicPosition(_atom.AtomicPosition),
+    AtomicElement(_atom.AtomicElement)
+{};
+
+AtomInfo::AtomInfo(const VectorInterface &_v) :
+    AtomicPosition(_v.getPosition()),
+    AtomicElement(NULL)
+{};
 
 /** Destructor of class AtomInfo.
@@ -22,14 +42,155 @@
 };
 
-const element *AtomInfo::getType(){
-  return type;
+const element *AtomInfo::getType() const
+{
+  return AtomicElement;
+}
+
+const double& AtomInfo::operator[](size_t i) const
+{
+  return AtomicPosition[i];
+}
+
+const double& AtomInfo::at(size_t i) const
+{
+  return AtomicPosition.at(i);
+}
+
+void AtomInfo::set(size_t i, const double value)
+{
+  AtomicPosition.at(i) = value;
+}
+
+const Vector& AtomInfo::getPosition() const
+{
+  return AtomicPosition;
 }
 
 void AtomInfo::setType(const element* _type) {
-  type = _type;
+  AtomicElement = _type;
 }
 
-void AtomInfo::setType(int Z) {
+void AtomInfo::setType(const int Z) {
   const element *elem = World::getInstance().getPeriode()->FindElement(Z);
   setType(elem);
 }
+
+void AtomInfo::setPosition(const Vector& _vector)
+{
+  AtomicPosition = _vector;
+  //cout << "AtomInfo::setPosition: " << getType()->symbol << " at " << getPosition() << endl;
+}
+
+const VectorInterface& AtomInfo::operator+=(const Vector& b)
+{
+  AtomicPosition += b;
+  return *this;
+}
+
+const VectorInterface& AtomInfo::operator-=(const Vector& b)
+{
+  AtomicPosition -= b;
+  return *this;
+}
+
+Vector const AtomInfo::operator+(const Vector& b) const
+{
+  Vector a(AtomicPosition);
+  a += b;
+  return a;
+}
+
+Vector const AtomInfo::operator-(const Vector& b) const
+{
+  Vector a(AtomicPosition);
+  a -= b;
+  return a;
+}
+
+double AtomInfo::distance(const Vector &point) const
+{
+  return AtomicPosition.distance(point);
+}
+
+double AtomInfo::DistanceSquared(const Vector &y) const
+{
+  return AtomicPosition.DistanceSquared(y);
+}
+
+double AtomInfo::distance(const VectorInterface &_atom) const
+{
+  return _atom.distance(AtomicPosition);
+}
+
+double AtomInfo::DistanceSquared(const VectorInterface &_atom) const
+{
+  return _atom.DistanceSquared(AtomicPosition);
+}
+
+VectorInterface &AtomInfo::operator=(const Vector& _vector)
+{
+  AtomicPosition = _vector;
+  return *this;
+}
+
+void AtomInfo::ScaleAll(const double *factor)
+{
+  AtomicPosition.ScaleAll(factor);
+}
+
+void AtomInfo::ScaleAll(const Vector &factor)
+{
+  AtomicPosition.ScaleAll(factor);
+}
+
+void AtomInfo::Scale(const double factor)
+{
+  AtomicPosition.Scale(factor);
+}
+
+void AtomInfo::Zero()
+{
+  AtomicPosition.Zero();
+}
+
+void AtomInfo::One(const double one)
+{
+  AtomicPosition.One(one);
+}
+
+void AtomInfo::LinearCombinationOfVectors(const Vector &x1, const Vector &x2, const Vector &x3, const double * const factors)
+{
+  AtomicPosition.LinearCombinationOfVectors(x1,x2,x3,factors);
+}
+
+const AtomInfo& operator*=(AtomInfo& a, const double m)
+{
+  a.Scale(m);
+  return a;
+}
+
+AtomInfo const operator*(const AtomInfo& a, const double m)
+{
+  AtomInfo copy(a);
+  copy *= m;
+  return copy;
+}
+
+AtomInfo const operator*(const double m, const AtomInfo& a)
+{
+  AtomInfo copy(a);
+  copy *= m;
+  return copy;
+}
+
+std::ostream & AtomInfo::operator << (std::ostream &ost) const
+{
+  return (ost << getPosition());
+}
+
+std::ostream & operator << (std::ostream &ost, const AtomInfo &a)
+{
+  ost << a;
+  return ost;
+}
+
Index: src/atom_atominfo.hpp
===================================================================
--- src/atom_atominfo.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_atominfo.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -19,28 +19,73 @@
 #endif
 
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/VectorInterface.hpp"
 
 /****************************************** forward declarations *****************************/
 
+class AtomInfo;
 class element;
+class Matrix;
 
 /********************************************** declarations *******************************/
 
-class AtomInfo {
+class AtomInfo : public VectorInterface {
+
 public:
-  Vector x;       //!< coordinate vector of atom, giving last position within cell
-  Vector v;       //!< velocity vector of atom, giving last velocity within cell
-  Vector F;       //!< Force vector of atom, giving last force within cell
-  const element *type;  //!< pointing to element
+  Vector AtomicVelocity;       //!< velocity vector of atom, giving last velocity within cell
+  Vector AtomicForce;       //!< Force vector of atom, giving last force within cell
 
   AtomInfo();
-  ~AtomInfo();
+  AtomInfo(const AtomInfo &_atom);
+  AtomInfo(const VectorInterface &_v);
+  virtual ~AtomInfo();
 
-  const element *getType();
+  const element *getType() const;
   void setType(const element *);
-  void setType(int);
+  void setType(const int);
+
+  ///// manipulation of the atomic position
+
+  // Accessors ussually come in pairs... and sometimes even more than that
+  const double& operator[](size_t i) const;
+  const double& at(size_t i) const;
+  void set(size_t i, const double value);
+  const Vector& getPosition() const;
+
+  // Assignment operator
+  void setPosition(const Vector& _vector);
+  class VectorInterface &operator=(const Vector& _vector);
+
+  // operators for mathematical operations
+  const VectorInterface& operator+=(const Vector& b);
+  const VectorInterface& operator-=(const Vector& b);
+  Vector const operator+(const Vector& b) const;
+  Vector const operator-(const Vector& b) const;
+
+  void Zero();
+  void One(const double one);
+  void LinearCombinationOfVectors(const Vector &x1, const Vector &x2, const Vector &x3, const double * const factors);
+
+  double distance(const Vector &point) const;
+  double DistanceSquared(const Vector &y) const;
+  double distance(const VectorInterface &_atom) const;
+  double DistanceSquared(const VectorInterface &_atom) const;
+
+  void ScaleAll(const double *factor);
+  void ScaleAll(const Vector &factor);
+  void Scale(const double factor);
+
+  std::ostream & operator << (std::ostream &ost) const;
 
 private:
+  Vector AtomicPosition;       //!< coordinate vector of atom, giving last position within cell
+  const element *AtomicElement;  //!< pointing to element
 };
 
+std::ostream & operator << (std::ostream &ost, const AtomInfo &a);
+
+const AtomInfo& operator*=(AtomInfo& a, const double m);
+AtomInfo const operator*(const AtomInfo& a, const double m);
+AtomInfo const operator*(const double m, const AtomInfo& a);
+
 #endif /* ATOM_ATOMINFO_HPP_ */
Index: src/atom_bondedparticle.cpp
===================================================================
--- src/atom_bondedparticle.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_bondedparticle.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -13,6 +18,6 @@
 #include "element.hpp"
 #include "lists.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 /** Constructor of class BondedParticle.
@@ -152,10 +157,10 @@
   NoBonds = CountBonds();
   //Log() << Verbose(3) << "Walker " << *this << ": " << (int)this->type->NoValenceOrbitals << " > " << NoBonds << "?" << endl;
-  if ((int)(type->NoValenceOrbitals) > NoBonds) { // we have a mismatch, check all bonding partners for mismatch
+  if ((int)(getType()->NoValenceOrbitals) > NoBonds) { // we have a mismatch, check all bonding partners for mismatch
     for (BondList::const_iterator Runner = ListOfBonds.begin(); Runner != ListOfBonds.end(); (++Runner)) {
       OtherWalker = (*Runner)->GetOtherAtom(this);
       OtherNoBonds = OtherWalker->CountBonds();
       //Log() << Verbose(3) << "OtherWalker " << *OtherWalker << ": " << (int)OtherWalker->type->NoValenceOrbitals << " > " << OtherNoBonds << "?" << endl;
-      if ((int)(OtherWalker->type->NoValenceOrbitals) > OtherNoBonds) { // check if possible candidate
+      if ((int)(OtherWalker->getType()->NoValenceOrbitals) > OtherNoBonds) { // check if possible candidate
         if ((CandidateBond == NULL) || (ListOfBonds.size() > OtherWalker->ListOfBonds.size())) { // pick the one with fewer number of bonds first
           CandidateBond = (*Runner);
@@ -189,2 +194,16 @@
 };
 
+std::ostream & BondedParticle::operator << (std::ostream &ost) const
+{
+  ParticleInfo::operator<<(ost);
+  ost << "," << getPosition();
+  return ost;
+}
+
+std::ostream & operator << (std::ostream &ost, const BondedParticle &a)
+{
+  a.ParticleInfo::operator<<(ost);
+  ost << "," << a.getPosition();
+  return ost;
+}
+
Index: src/atom_bondedparticle.hpp
===================================================================
--- src/atom_bondedparticle.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_bondedparticle.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -49,8 +49,11 @@
   void OutputOrder(ofstream *file) const;
 
+  std::ostream & operator << (std::ostream &ost) const;
+
 private:
 
 };
 
+std::ostream & operator << (std::ostream &ost, const BondedParticle &a);
 
 #endif /* ATOM_BONDEDPARTICLE_HPP_ */
Index: src/atom_bondedparticleinfo.cpp
===================================================================
--- src/atom_bondedparticleinfo.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_bondedparticleinfo.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -12,5 +17,8 @@
 /** Constructor of class BondedParticleInfo.
  */
-BondedParticleInfo::BondedParticleInfo() : AdaptiveOrder(0), MaxOrder(false) {};
+BondedParticleInfo::BondedParticleInfo() :
+  AdaptiveOrder(0),
+  MaxOrder(false)
+{};
 
 /** Destructor of class BondedParticleInfo.
Index: src/atom_bondedparticleinfo.hpp
===================================================================
--- src/atom_bondedparticleinfo.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_bondedparticleinfo.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -36,5 +36,5 @@
 
   BondedParticleInfo();
-  ~BondedParticleInfo();
+  virtual ~BondedParticleInfo();
 
 private:
Index: src/atom_graphnode.cpp
===================================================================
--- src/atom_graphnode.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_graphnode.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,9 +6,14 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "atom_graphnode.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 /** Constructor of class GraphNode.
